clear all, close all,clc, warning off


fname = ['accelerometer_copia.xls'];
[dat,txt,all] = xlsread(fname);

t = dat(:,1);
x = dat(:,2);
y = dat(:,3);
z = dat(:,4);

nt = [100:100:max(t)];
nx = interp1(t,x,nt);
ny = interp1(t,y,nt);
nz = interp1(t,z,nt);

clear dat all txt fname

%%
figure(1)
subplot(3,1,1)
plot((nt./1000)./60,nx)
ylabel('X [m/s2]')
xlabel('Tiempo [min]')
grid on

subplot(3,1,2)
plot((nt./1000)./60,ny)
ylabel('Y [m/s2]')
xlabel('Tiempo [min]')
grid on

subplot(3,1,3)
plot((nt./1000)./60,nz)
ylabel('Z [m/s2]')
xlabel('Tiempo [min]')
grid on


%%
Fs = 1000*(1./100);      % 10 oscilaciones x segundo

L = length(nt);
NFFT = 4096;
X = fft(nx,NFFT)/L;     X(1:2) = nan;
Y = fft(ny,NFFT)/L;     Y(1:2) = nan;
Z = fft(nz,NFFT)/L;     Z(1:2) = nan;

f = Fs/2*linspace(0,1,NFFT/2+1);

% Plot de un lado del espectro de amplitud.
figure
subplot(311)
plot(f,2*abs(X(1:NFFT/2+1))) 
title('Espectro de Amplitud X(t)')
xlabel('Frecuencia (Hz)')
ylabel('|X(f)|')
% ylim([0 0.04])
grid on


subplot(312)
plot(f,2*abs(Y(1:NFFT/2+1))) 
title('Espectro de Amplitud Y(t)')
xlabel('Frecuencia (Hz)')
ylabel('|Y(f)|')
% ylim([0 0.04])
grid on


subplot(313)
plot(f,2*abs(Z(1:NFFT/2+1))) 
title('Espectro de Amplitud Z(t)')
xlabel('Frecuencia (Hz)')
ylabel('|Z(f)|')
% ylim([0 0.04])
grid on



%%
figure
subplot(311)
plot(1./f,2*abs(X(1:NFFT/2+1))) 
title('Espectro de Amplitud X(t)')
xlabel('Periodo (Seg)')
ylabel('|X(f)|')
% ylim([0 0.04])
grid on


subplot(312)
plot(1./f,2*abs(Y(1:NFFT/2+1))) 
title('Espectro de Amplitud Y(t)')
xlabel('Periodo (Seg)')
ylabel('|Y(f)|')
% ylim([0 0.04])
grid on


subplot(313)
plot(1./f,2*abs(Z(1:NFFT/2+1))) 
title('Espectro de Amplitud Z(t)')
xlabel('Periodo (Seg)')
ylabel('|Z(f)|')
% ylim([0 0.04])
grid on



%%

figure
subplot(311)
[a,b] = hist(nx,[-1:0.1:12]);
bar(b,100*a/sum(a),1)
xlabel('Acelerometro X [m/s2]')
grid on
set(gca,'xtick',[-1:0.5:12])
xlim([-1 12])
ylabel('%')

subplot(312)
[a,b] = hist(ny,[-1:0.1:12]);
bar(b,100*a/sum(a),1)
xlabel('Acelerometro Y [m/s2]')
grid on
set(gca,'xtick',[-1:0.5:12])
xlim([-1 12])
ylabel('%')

subplot(313)
[a,b] = hist(nz,[-1:0.1:12]);
bar(b,100*a/sum(a),1)
xlabel('Acelerometro Z [m/s2]')
grid on
set(gca,'xtick',[-1:0.5:12])
xlim([-1 12])
ylabel('%')